<?php


// リムーブ
remove_action( 'wp_head',             'wp_enqueue_scripts',            1     );
remove_action( 'wp_head',             'feed_links',                    2     );
remove_action( 'wp_head',             'feed_links_extra',              3     );
remove_action( 'wp_head',             'rsd_link'                             );
remove_action( 'wp_head',             'wlwmanifest_link'                     );
remove_action( 'wp_head',             'index_rel_link'                       );
remove_action( 'wp_head',             'parent_post_rel_link',          10, 0 );
remove_action( 'wp_head',             'start_post_rel_link',           10, 0 );
remove_action( 'wp_head',             'adjacent_posts_rel_link_wp_head', 10, 0 );
// remove_action( 'wp_head',             'wp_print_styles',               8     );
// remove_action( 'wp_head',             'wp_print_head_scripts',         9     );
remove_action( 'wp_head',             'wp_generator'                         );
remove_action( 'wp_head',             'rel_canonical'                        );
remove_action( 'wp_head',             'wp_shortlink_wp_head'                 );
remove_action( 'wp_footer',           'wp_print_footer_scripts'              );


// 他フィルター
//remove_filter( 'the_excerpt',         'wptexturize'); // 抜粋の自動置換を無効
//remove_filter( 'the_title',           'wptexturize'); // 記事タイトルの自動置換を無効
remove_filter( 'the_content',         'wptexturize'); // 本文の自動置換を無効
remove_filter( 'the_content',         'wpautop'); // 本文pタグの自動挿入禁止
remove_filter( 'the_excerpt',         'wpautop'); // 抜粋pタグの自動挿入禁止


// Top Level Categories
// Filipe Fortes
// http://fortes.com/projects/wordpress/top-level-cats/
if (function_exists('add_action')) {
	register_activation_hook(__FILE__, 'top_level_cats_activate');
	register_deactivation_hook(__FILE__, 'top_level_cats_deactivate');

	// Setup filters
	add_filter('category_rewrite_rules', 'top_level_cats_category_rewrite_rules');
	add_filter('generate_rewrite_rules', 'top_level_cats_generate_rewrite_rules');
	add_filter('category_link', 'top_level_cats_category_link', 10, 2);
	
	global $clean_category_rewrites, $clean_rewrites;
	$clean_category_rewrites = array();
}

function top_level_cats_activate() {
	global $wp_rewrite;
	$wp_rewrite->flush_rules();
}

function top_level_cats_deactivate() {
	// Remove the filters so we don't regenerate the wrong rules when we flush
	remove_filter('category_rewrite_rules', 'top_level_cats_category_rewrite_rules');
	remove_filter('generate_rewrite_rules', 'top_level_cats_generate_rewrite_rules');
	remove_filter('category_link', 'top_level_cats_category_link');

	global $wp_rewrite;
	$wp_rewrite->flush_rules();
}

function top_level_cats_generate_rewrite_rules($wp_rewrite) {
	global $clean_category_rewrites;
	$wp_rewrite->rules = $wp_rewrite->rules + $clean_category_rewrites;
}

function top_level_cats_category_rewrite_rules($category_rewrite) {
	global $clean_category_rewrites;

  global $wp_rewrite;
  // Make sure to use verbose rules, otherwise we'll clobber our
  // category permalinks with page permalinks
  $wp_rewrite->use_verbose_page_rules = true;

	while (list($k, $v) = each($category_rewrite)) {
		// Strip off the category prefix
		$new_k = top_level_cats_remove_cat_base($k);
		$clean_category_rewrites[$new_k] = $v;
	}

	return $category_rewrite;
}

function top_level_cats_category_link($cat_link, $cat_id) {
	return top_level_cats_remove_cat_base($cat_link);
}

function top_level_cats_remove_cat_base($link) {
	$category_base = get_option('category_base');
	
	// WP uses "category/" as the default
	if ($category_base == '') 
		$category_base = 'category';

	// Remove initial slash, if there is one (we remove the trailing slash in the regex replacement and don't want to end up short a slash)
	if (substr($category_base, 0, 1) == '/')
		$category_base = substr($category_base, 1);

	$category_base .= '/';

	return preg_replace('|' . $category_base . '|', '', $link, 1);
}


// パンくずナビ
function get_breadcrumbs(){
	global $wp_query;

	if ( is_home() ){
		$home_page_title = get_bloginfo('name');
		echo '<ul><li class="first">' . $home_page_title . '</li>';
	} else {
		echo '<ul>';
		$home_page_title = get_bloginfo('name');
		echo '<li class="first">' . $home_page_title . '</li>';

		if ( is_category() ) {
			$catTitle = single_cat_title( '', false );
			echo '<li>' . $catTitle .'</li>';
		} elseif ( is_archive() && !is_category() ) {
			echo '<li>' . $catTitle .'</li>';
		} elseif ( is_404() ) {
			echo "<li>" . __('Page not found') . "</li>";
		} elseif ( is_single() ) {
			echo '<li>';
			$cat = get_the_category();
			$cat = $cat[0]; { echo $cat->cat_name; }
			echo '</li>';
		} elseif ( is_page() ) {
			$post = $wp_query->get_queried_object();
			if ( $post->post_parent == 0 ){
				echo "<li>" . the_title('','', FALSE)."</li>";
			} else {
				$title = the_title('','', FALSE);
				$ancestors = array_reverse( get_post_ancestors( $post->ID ) );
				array_push($ancestors, $post->ID);
				foreach ( $ancestors as $ancestor ){
					if( $ancestor != end($ancestors) ){
						echo '<li>'  . $separate . '<a href="'. get_permalink($ancestor) .'">'. strip_tags( apply_filters( 'single_post_title', get_the_title( $ancestor ) ) ) .'</a></li>';
					} else {
						echo '<li>' . strip_tags( apply_filters( 'single_post_title', get_the_title( $ancestor ) ) ) .'</li>';
					}
				}
			}
		}
		// End the UL
		echo "</ul>";
	}
}


// 投稿内にPHPを読み込むショートコード
function Include_my_php($params = array()) {
	extract(shortcode_atts(array(
		'file' => 'default'
	), $params));
	ob_start();
	include(get_theme_root() . '/' . get_template() . "/myphpfiles/$file.php");
	return ob_get_clean();
}  

add_shortcode('myphp', 'Include_my_php'); 


// 抜粋表示関連
function new_excerpt_more($more) {
	return '';
}
add_filter('excerpt_more', 'new_excerpt_more');


// フッターカテゴリーリスト
function nest_cat() {
	$categories = get_categories('exclude=1&hide_empty=0');
	if ( is_array($categories) ) {
		foreach($categories as $category):
			$v_cat_id = $category->cat_ID;
			$v_cat_Parent_title = $category->cat_name;
			$v_cat_Parent_url = get_category_link($v_cat_id);
			$v_cat_child_list = wp_list_categories('hide_empty=0&title_li=&child_of=$v_cat_id&echo=0');

			echo "<a href=\"$v_cat_Parent_url\">$v_cat_Parent_title</a>｜";

			if ( strpos($v_cat_child_list, __('No categories')) === false) {
				echo "<ul>\n$v_cat_child_list\n</ul>\n";
			}
		endforeach;
	}
}

// フッターページリスト
function nest_page( $pages ) {
    foreach ($pages as $page) {
        $title = apply_filters( 'the_title', $page->post_title );
        $excerpt = apply_filters( 'the_excerpt', $page->post_excerpt);
        $page_link = esc_url(get_page_link($page->ID));

	echo "<a href=\"$page_link\">$title</a>｜";

        $child_pages = get_pages('hierarchical=0&child_of='.$page->ID);
        if (!(empty($child_pages))) nest_page($child_pages); 
    }
}


// キーワード
function top_keywords($keywords) {
	$keyid = get_category(1);
	$keyid = (array)$keyid;
	$keywords = get_post_meta( $keyid['object_id'] , 'Keyword' , true );
	return $keywords;
}



// 管理画面関連
function custom_admin() {
	echo '<link rel="stylesheet" type="text/css" href="'.get_bloginfo('template_directory').'/custom-admin-style.css" />';
}

function custom_login_logo() {
        echo '<style type="text/css">h1 a { background: url('.get_bloginfo('template_directory').'/images/admin/logo-login.png) 50% 50% no-repeat !important; padding-top: 10px; }</style>';
}
add_action('login_head', 'custom_login_logo');
add_action('admin_head', 'custom_admin');



remove_all_actions('wp_dashboard_setup');

function example_remove_dashboard_widgets() {

	global $wp_meta_boxes;

	//Main column
//	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_right_now']);//現在の状況
	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_recent_comments']);//最近のコメント
	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_incoming_links']);//被リンク
	unset($wp_meta_boxes['dashboard']['normal']['core']['dashboard_plugins']);//プラグイン

	//Side Column
	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_quick_press']);//クイック投稿
//	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_recent_drafts']);//最近の下書き
	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_primary']);//開発ブログ
	unset($wp_meta_boxes['dashboard']['side']['core']['dashboard_secondary']);//フォーラム

}

add_action('wp_dashboard_setup', 'example_remove_dashboard_widgets' );

function remove_menus () {
	global $menu;
//	unset($menu[2]);// ダッシュボード
	unset($menu[4]);// メニューの線1
//	unset($menu[5]);// 投稿
//	unset($menu[9]);//　投稿タグ
	unset($menu[10]);// メディア
	unset($menu[15]);// リンク
//	unset($menu[20]);// ページ
	unset($menu[25]);// コメント
	unset($menu[59]);// メニューの線2
//	unset($menu[60]);// テーマ
//	unset($menu[65]);// プラグイン
//	unset($menu[70]);// ユーザー
	unset($menu[75]);// ツール
//	unset($menu[80]);// 設定
	unset($menu[90]);// メニューの線3
}
add_action('admin_menu', 'remove_menus');


function help_page() {
	$siteurl = get_option( 'siteurl' );
	include_once(TEMPLATEPATH . '/help.php');
}
function help_admin_menu() {
	add_menu_page( 'ヘルプ', 'ヘルプ', 'read', __FILE__, 'help_page' );
}
add_action( 'admin_menu', 'help_admin_menu' );
